import hyperdiv as hd
from .text_utils import code_example, markdown_with_code_examples


def how_it_works():
    markdown_with_code_examples(
        """
        # How Hyperdiv Works

        Borrows from FRP, Immediate Mode UI, HeadSpin HeadSpin LiveEval, Quora Webnode2/LiveNode

        https://semilshah.com/2011/08/15/the-significance-of-quoras-livenode-technology/
        https://bigfastblog.com/quoras-technology-examined#webnode2-and-livenode
        https://www.quora.com/Quoras-Technical-Infrastructure-How-does-LiveNode-work
        https://www.quora.com/How-is-Pythons-with-keyword-being-used-in-this-code-from-Livenode-Webnode/answer/Feross-Aboukhadijeh?srid=Rb

        **Reactive view framework**

        **Re-calculates the view when something changes**

        **State changes in response to events.**

        Hyperdiv is a *reactive function* framework. As a function
        runs, it registers dependencies. When one of those
        dependencies changes, the function runs again -- in other
        words, it reacts to the changes.

        Like in React, the function defines the *view*. When the
        function runs, it spits out a UI description (akin to HTML
        DOM, or React Virtual DOM) that is sent to the browser and
        rendered.

        So the function has to be written in such a way so it can run
        at any time. If no state changed, running the function again
        will just output the same view as the last run. When something
        changed, though, the view may be different, due to conditional
        rendering based on state.

        State changes in response to events:

        * Users interact with the UI and mutate state
            * Clicking a button, typing in a text box, checking a checkbox, etc.
        * App code further mutates state in response to events

        Props

        Dependencies

        """
    )
